/* SiME Widget About Box */

/* Copyright 2021 Kazuo K.
 * SiME is licensed under the MIT license. You should have
 * received a copy of the license with your distribution.
 */

/* Std C Headers */
#include <stdio.h>

/* X11/Motif Headers */
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/Separator.h>
#include <Xm/PushB.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/DrawingA.h>

/* Local Headers */
#include "globals.h"
#include "sys_consts.h"
#include "utils.h"

/* Local Functions */
static void close_dlg(Widget w, XtPointer client_data, XtPointer call_data);

static char *about_msg = "SiME - Version "VERSION" Rev '"DATE"'\n"
    "Clone of simple motif editors like asedit and gloe";

static Widget  about_box = (Widget)0;

void  gui_about(void)
{
   Widget         form;
   Widget         form1, sep, form2;
   Widget         lbl,btn;
   XmString       msg;
   XGCValues      gc_vals;
   unsigned long  tmp_col;

   if (about_box != (Widget)0)
   {
      XMapRaised(XtDisplay(about_box), XtWindow(about_box));
      return;
   }

   about_box = XtVaCreatePopupShell("About", xmDialogShellWidgetClass, toplevel,
			XmNdeleteResponse, XmDESTROY,
			NULL);

   form = XtVaCreateWidget("form", xmFormWidgetClass, about_box, NULL);

   form1 = XtVaCreateWidget("form1", xmFormWidgetClass, form,
			XmNtopAttachment,   XmATTACH_FORM,
			XmNleftAttachment,  XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			NULL);

   msg = XmStringCreateLtoR(about_msg, CHARSET);
   lbl = XtVaCreateManagedWidget("label", xmLabelWidgetClass, form1,
			XmNlabelString,      msg,
			XmNtopAttachment,    XmATTACH_FORM,
			XmNtopOffset,        10,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset,     10,
			XmNrightAttachment,  XmATTACH_FORM,
			XmNrightOffset,      10,
			NULL);
   XmStringFree(msg);

   XtManageChild(form1);

   sep = XtVaCreateManagedWidget("sep", xmSeparatorWidgetClass, form,
			XmNtopAttachment,   XmATTACH_WIDGET,
			XmNtopWidget,       form1,
			XmNleftAttachment,  XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			NULL);

   form2 = XtVaCreateWidget("form2", xmFormWidgetClass, form,
			XmNfractionBase,     3,
			XmNtopAttachment,    XmATTACH_WIDGET,
			XmNtopWidget,        sep,
			XmNleftAttachment,   XmATTACH_FORM,
			XmNrightAttachment,  XmATTACH_FORM,
			XmNbottomAttachment, XmATTACH_FORM,
			NULL);
   btn = XtVaCreateManagedWidget("Ok", xmPushButtonWidgetClass, form2,
			XmNtopAttachment,    XmATTACH_FORM,
			XmNtopOffset,        5,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset,     5,
			XmNleftAttachment,   XmATTACH_POSITION,
			XmNleftPosition,     1,
			XmNrightAttachment,  XmATTACH_POSITION,
			XmNrightPosition,    2,
			NULL);
   XtManageChild(form2);
   XtAddCallback(btn, XmNactivateCallback, close_dlg, (XtPointer)about_box);

   XtManageChild(form);

   tmp_col = gc_vals.foreground;
   gc_vals.foreground = gc_vals.background;
   gc_vals.background = tmp_col;


   XtPopup(about_box, XtGrabNone);
}


static void close_dlg(Widget w, XtPointer client_data, XtPointer call_data)
{
   Widget  shell = (Widget)client_data;
   about_box = (Widget)0;
   XtDestroyWidget(shell);
}

