
#include <Xm/Xm.h>
#include <Xm/Text.h>

#include "sys_consts.h"
#include "callbacks.h"
#include "globals.h"

static void NoOp(Widget w, XEvent *ev, String *params, Cardinal *num_params)
{
}

static void DeleteLine(Widget w, XEvent *ev, String *params, Cardinal *num_params)
{
   Position        x, y, h;
   XmTextPosition  pos, p_start, p_end;

   pos = XmTextGetCursorPosition(w);
   XmTextPosToXY(w, pos, &x, &y);  // Find the cursor position

   p_start = p_end = XmTextXYToPos(w, 0, y);  // Find the beginning of line

   for (h=1; (p_start == p_end) && (h < 100); h++) 
      p_end   = XmTextXYToPos(w, 0, y+h); 

   if (p_end != p_start)               
      XmTextReplace(w, p_start, p_end, "");     

   XmTextSetCursorPosition(w, p_start); 
}

static void SearchAction(Widget w, XEvent *ev, String *params, Cardinal *num_params)
{
   gui_search_repl_CB(w, (XtPointer) SEARCH, NULL);
}

static XtActionsRec actions[] =
{
   {"no-operation", NoOp},
   {"delete-line", DeleteLine},
   {"search-action", SearchAction}
};


void  InstallActions(void)
{
   XtAppAddActions(app_context, actions, XtNumber(actions));
}
