#include <X11/cursorfont.h>
#include <Xm/Xm.h>
#include <Xm/Text.h>

#include "sys_consts.h"
#include "globals.h"
#include "utils.h"
#include "callbacks.h"
#include "undo.h"

int   changes_counter;

void  cut_copy_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
   int      reason = (uintptr_t)client_data;
   XEvent  *event = ((XmPushButtonCallbackStruct *)call_data)->event;
   Time     when;

   if (event != NULL)
   {
      switch (event->type)
      {
         case ButtonRelease:
            when = event->xbutton.time;
            break;

         case KeyRelease:
            when = event->xkey.time;
            break;

         default:
            when = CurrentTime;
            break;
      }
   }
   else
      when = CurrentTime;

   switch (reason)
   {
      case 0:
         XmTextCut(text_canvas, when);
         break;

      case 1:
         XmTextCopy(text_canvas, when);
         break;
   }
}

void  gui_paste_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
   XmTextPaste(text_canvas);
}

void  gui_undo_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
   action_undo_redo((uintptr_t)client_data);
}

void  gui_keypress_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
      if (!undo_redo_action)
	 save_action_for_undo(w, client_data, call_data);
      undo_redo_action = False;

      if ((changes_counter == 0) || (changes_counter == 1))
	 set_title_string();
}
