/* SiME heap_string.header */

/* Copyright 2021 Kazuo K.
 * SiME is licensed under the MIT license. You should have
 * received a copy of the license with your distribution.
 */

#ifndef DSTRING
#define DSTRING

typedef struct {
   char  *str;
   int    len;
} hstring;

void heap_string_init(hstring *ds);
void heap_string_new(hstring *ds, char *str);
void heap_string_compose(hstring *ds, ...);
void heap_string_cat(hstring *ds, char *str);
void heap_strncat(hstring *ds, char *str, int n);
void heap_string_free(hstring *ds);

char  *Xstrdup(char *str);
char  *Xstrndup(char *str, int n);


#endif
