/* SiME Constants */

/* Copyright 2021 Kazuo K.
 * SiME is licensed under the MIT license. You should have
 * received a copy of the license with your distribution.
 */
#ifndef SYS_CONSTS
#define SYS_CONSTS

#define PERSISTENT_UNDO

#define CHARSET		XmSTRING_DEFAULT_CHARSET

#define BELL_VOL	20

#undef NO_LARGE_FILES
#define MAX_DOCUMENT_LENGTH 350000

#define	SEPCHARS	" ,\t\n"

#define AUTO_SAVE_TIME     100
#define MIN_AUTO_SAVE_TIME  20

typedef enum {
   HELPCALL,
   HELPCANCEL,
   HELPSEARCH,
   HELPHELP,
   HELPSETUP,
   HELPABOUT
} HelpReason;

typedef enum {
   NEW,
   OPEN,	INSERT,
   SAVE,	SAVEAS,
   QUIT,
   CUT,		COPY,		PASTE,
   UNDO,	REDO,
   SEARCH,	REPLACE,	REPLACEALL,
   MATCH,	SELECTIONONLY,
   SETUP,
   HELPB,
   JUMP,	JUMPTEXT,
   SEARCHTEXT,	REPLACETEXT
} HelpItem;

typedef enum {
   OPENIT,
   APPENDIT,
   SAVE_ALL,
   SAVE_AS,
} FileMode;

#define NOTHING	     -1
#define NO	      0
#define YES	      1
#define HELP	      2
#define SAVE_THEN_DO  3

#endif
